<?php 
/**
 * @version		$Id: statistics.php,v 1.6 2012-07-25 19:04:01 juanca Exp $
 * @package		VPL. Report student submissions statistics
 * @copyright	2012 Juan Carlos Rodríguez-del-Pino
 * @license		http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 * @author		Juan Carlos Rodríguez-del-Pino <jcrodriguez@dis.ulpgc.es>
 */
die;
require_once dirname(__FILE__).'/../../../config.php';
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once dirname(__FILE__).'/../vpl_submission.class.php';
require_once dirname(__FILE__).'/statistics.class.php';
$id = required_param('id', PARAM_INT);
$group = optional_param('group', -1, PARAM_INT);
$vpl = new mod_vpl($id);
$vpl->prepare_page();

$course = $vpl->get_course();
$cm = $vpl->get_course_module();
$vplid = $vpl->get_instance()->id;
$context_module = $vpl->get_context();
$vpl->require_capability(VPL_GRADE_CAPABILITY);
$vpl->add_to_log('view statistics', vpl_rel_url('/views/statistics.php','id',$id), $vpl->get_printable_name());
//Print header
$vpl->print_header(get_string('statistics'));
$vpl->print_view_tabs(basename(__FILE__));
// find out current groups mode
$groupmode = groups_get_activity_groupmode($cm);
$currentgroup = groups_get_activity_group($cm, true);
//TODO review 
if ($currentgroup) {
	$user_list = get_users_by_capability($context_module, 'moodle/legacy:student', '', '', '', '', $currentgroup, '', false);
} else {
	$user_list = get_users_by_capability($context_module, 'moodle/legacy:student', '', '', '', '', '', '', false);
}
if($user_list == null){ //No user
	$vpl->print_footer();
	die;
}
//Menu for groups
if ($groupmode == VISIBLEGROUPS) {
	$baseurl =vpl_mod_href('views/statistics.php','id',$id);
	groups_print_activity_menu($cm, $baseurl);
}
echo '<br />';
@ob_flush();
flush();
//Total students
//Total & percentage of asigment submitted
//Total & percentage automatic evaluation
//Total submissions
//Total submissions evalated and %
//Average & deviation of aubmissions by student
//Average & deviation of days from last submmission to due time
//Average & deviation of periods of submission by student
//Graders
//Total evaluates & percentage
//All grades and % ??

//Load strings
$str_students 				= get_string('students');
$str_submissions			= get_string('submissions');
$str_automatic_evaluations	= get_string('automatic_evaluations');
$str_submissions			= get_string('submissions');
$str_evaluations			= get_string('evaluations');
$str_executions				= get_string('executions');
$table = new html_table();
$table->head  = array (get_string('parm'),get_string('value'));
$table->aling = array ('right','right');
$table->size = array ('','20');
$all_submissions = $DB->get_records(VPL_SUBMISSIONS, array('vpl' => $vplid),
					'userid','id,userid,datesubmitted,grader,dategraded,grade');
$nusers=0;
$ngrades = array();
$last_userid=-1;
$stat_subs = new vpl_statistics();
$stat_eval = new vpl_statistics();
$stat_exec = new vpl_statistics();

foreach ($all_submissions as $id => $sub) {
	if(! isset($user_list[$sub->userid])){
		continue;
	}
	if($sub->userid != $last_userid){
		if($last_userid>=0){
			$stat_subs->count_item();
			$stat_eval->count_item();
			$stat_exec->count_item();
		}
		$last_userid=$sub->userid;
	}
	$stat_subs->count();  //count submission for this user
	$submission = new mod_vpl_submission($vpl,$sub);
	if($submission->is_graded()){
	}
	$CE = $submission->getCE();
	if($CE['compilation'] !== 0 || $CE['executed'] ){ //Compilation
		$stat_eval->count();
	}
	if($CE['executed'] ){ //executed
		$stat_exec->count();
	}
}
//Unblock user session
session_write_close();
if($last_userid>=0){
	$stat_subs->count_item();
	$stat_eval->count_item();
	$stat_exec->count_item();
}
echo '<br />';
//Total students
//Total & percentage of asigment submitted
//Total & percentage automatic evaluation
//Total submissions
//Total submissions evalated and %
//Average & deviation of aubmissions by student
//Average & deviation of days from last submmission to due time
//Average & deviation of periods of submission by student
//Graders
//Total evaluates & percentage
//All grades and % ??
$table->data[]=array(get_string('students'),count($user_list));
$table->data[]=array(get_string('submission'),$stat_subs->sprint_all());
$table->data[]=array(get_string('evalation'),$stat_eval->sprint_all());
$table->data[]=array(get_string('execution'),$stat_exec->sprint_all());
echo html_writer::table($table);

$vpl->print_footer();
?>